//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

String ArticlesXML;
String ReportFile;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ArticlesXML = ExtractFilePath(Application->ExeName) + "Articles.xml";
  if (FileExists(ArticlesXML))
    cdsArt->LoadFromFile(ArticlesXML);
  else
    cdsArt->CreateDataSet();
  cdsArt->LogChanges = false;
  cdsArt->IndexFieldNames = "Name";  // order grid on field NAME
  cdsArt->First();
  TFilterOptions FilterOptions;
  FilterOptions << foCaseInsensitive;
  cdsArt->FilterOptions = FilterOptions;
  ReportFile = ExtractFilePath(Application->ExeName) + "Report.htm";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  cdsArt->MergeChangeLog();
  cdsArt->SaveToFile(ArticlesXML);
}
//----------------------------------------------------------------------------
void __fastcall TForm1::btnFindIDClick(TObject *Sender)
{
  String ID = edFind->Text;
  ID = Trim(ID.UpperCase());
  edFind->Text = ID;
  cdsArt->IndexFieldNames = "ID";  // order grid on field ID
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnFindNameClick(TObject *Sender)
{
  String Name = edFind->Text;
  Name = Trim(Name);
  cdsArt->IndexFieldNames = "Name";  // order grid on field Name
  cdsArt->FindNearest(ARRAYOFCONST((Name)));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cbFilterClick(TObject *Sender)
{
  String Filt = Trim(edFind->Text);
  if (cbFilter->Checked) {
    cdsArt->Filter = "Name='" + Filt + "'";
    cdsArt->Filtered = true;
  }
  else
    cdsArt->Filtered = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnReportClick(TObject *Sender)
{
  String SLine;
  Memo1->Clear();
  Memo1->Lines->Add("<!DOCTYPE html><html><head><title>Report</title></head>");
  Memo1->Lines->Add("<body><table cellspacing='0' cellpadding='3' border='1'>");
  Memo1->Lines->Add("<tr><td>ID</td><td>Name</td><td>Type</td><td>Price</td><td>Stock</td></tr>");
  cdsArt->First();
  while (!(cdsArt->Eof)) {
    SLine = "<tr><td>" + cdsArt->FieldByName("ID")->AsString + "</td>";
    SLine += "<td>" + cdsArt->FieldByName("Name")->AsString + "</td>";
    SLine += "<td>" + cdsArt->FieldByName("Type")->AsString + "</td>";
    SLine += "<td align='right'>" + FormatFloat("0.00",
      cdsArt->FieldByName("Price")->AsFloat) + "</td></td>";
    SLine += "<td align='right'>" + cdsArt->FieldByName("Stock")->AsString +
      "</td></tr>";
    Memo1->Lines->Add(SLine);
    cdsArt->Next();
  };
  Memo1->Lines->Add("</table></body></html>");
  Memo1->Lines->SaveToFile(ReportFile);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnReportViewClick(TObject *Sender)
{
  if (FileExists(ReportFile))
    // ShellExecute does not accept Unicode strings, use S.c_strc()
    ShellExecute(NULL, L"open", ReportFile.c_str(), NULL, NULL, SW_SHOWNORMAL);
  else
    ShowMessage("Firstly, create a report");
}
//---------------------------------------------------------------------------

